Index: trunk/LMDZ.TITAN/libf/muphytitan/cfgparse.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/cfgparse.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/cfgparse.F90	(revision 1897)
@@ -1,21 +1,21 @@
-! Copyright Jérémie Burgalat (2010-2015)
-! 
-! burgalat.jeremie@gmail.com
-! 
-! This software is a computer program whose purpose is to provide configuration 
+! Copyright Jérémie Burgalat (2010-2015,2017)
+!
+! jeremie.burgalat@univ-reims.fr
+!
+! This software is a computer program whose purpose is to provide configuration
 ! file and command line arguments parsing features to Fortran programs.
-! 
+!
 ! This software is governed by the CeCILL-B license under French law and
-! abiding by the rules of distribution of free software.  You can  use, 
+! abiding by the rules of distribution of free software.  You can  use,
 ! modify and/ or redistribute the software under the terms of the CeCILL-B
 ! license as circulated by CEA, CNRS and INRIA at the following URL
-! "http://www.cecill.info". 
-! 
+! "http://www.cecill.info".
+!
 ! As a counterpart to the access to the source code and  rights to copy,
 ! modify and redistribute granted by the license, users are provided only
 ! with a limited warranty  and the software's author,  the holder of the
 ! economic rights,  and the successive licensors  have only  limited
-! liability. 
-! 
+! liability.
+!
 ! In this respect, the user's attention is drawn to the risks associated
 ! with loading,  using,  modifying and/or developing or reproducing the
@@ -25,15 +25,15 @@
 ! professionals having in-depth computer knowledge. Users are therefore
 ! encouraged to load and test the software's suitability as regards their
-! requirements in conditions enabling the security of their systems and/or 
-! data to be ensured and,  more generally, to use and operate it in the 
-! same conditions as regards security. 
-! 
+! requirements in conditions enabling the security of their systems and/or
+! data to be ensured and,  more generally, to use and operate it in the
+! same conditions as regards security.
+!
 ! The fact that you are presently reading this means that you have had
 ! knowledge of the CeCILL-B license and that you accept its terms.
 
 !! file: cfgparse.F90
-!! summary: Configuration file parser source file
-!! author: burgalat
-!! date: 2013-2015, 2017
+!! summary: Configuration file parser source file.
+!! author: J. Burgalat
+!! date: 2013-2015,2017
 
 #include "defined.h"
@@ -41,11 +41,14 @@
 MODULE CFGPARSE
   !! Configuration file parsing module
-  !!  
-  !! This module defines a set of derived types as well as methods to parse configuration files. 
+  !!
+  !! This module defines a set of derived types as well as methods to parse configuration files.
+  !!
+  !! If you only wish to have an overview of cfgparse usage, you'd better go
+  !! [here](|url|/page/swift/p02_cfgparse.html).
   !! @todo
-  !! Add interpolation from environment and/or parser options
+  !! Add interpolation from environment and/or parser options.
   USE, INTRINSIC :: ISO_FORTRAN_ENV
   USE ERRORS
-  USE STRINGS
+  USE STRING_OP
   USE FSYSTEM
   IMPLICIT NONE
@@ -56,4 +59,5 @@
             cfg_get_value, cfg_set_value, cfg_count, cfg_check_name, &
             cfg_has_option, cfg_has_section, &
+            cfg_option_names,cfg_section_names, &
             cfg_remove_option, cfg_remove_section, &
             cfg_sort_options
@@ -63,5 +67,5 @@
   ! some public definitions from other modules
   ! from strings
-  PUBLIC :: str_to_lower,st_slen, st_llen
+  PUBLIC :: to_lower,st_slen, st_llen
 
   PUBLIC :: OPERATOR(==), OPERATOR(/=), ASSIGNMENT(=)
@@ -76,6 +80,6 @@
   TYPE, PUBLIC :: cfgparser
     !! Define a parser of options
-    !! 
-    !! A [[cfgparser(type)]] stores [[option(type)]] objects. 
+    !!
+    !! A [[cfgparser(type)]] stores [[option(type)]] objects.
     TYPE(option), DIMENSION(:), ALLOCATABLE  :: options !! list of options.
 #if HAVE_FTNPROC
@@ -124,7 +128,7 @@
     PROCEDURE, PUBLIC :: remove_option  => cfg_remove_option
     !> Remove a section (and all the associated options) from the parser.
-    PROCEDURE, PUBLIC :: remove_section => cfg_remove_section 
-    !> Get value(s) of an option in the parser by name 
-    !! 
+    PROCEDURE, PUBLIC :: remove_section => cfg_remove_section
+    !> Get value(s) of an option in the parser by name
+    !!
     !! ```
     !! FUNCTION cfg_get_value(this,name,output) RESULT(error)
@@ -135,8 +139,8 @@
     !! On error, __output__ argument is undefined (that is, left unchanged
     !! for scalar versions, **unallocated** for vector version).
-    !! 
+    !!
     !! Errors occur in the following situations:
     !! - The option has no value (-6)
-    !! - The option does not exist (-7) 
+    !! - The option does not exist (-7)
     !! - The option's value cannot be cast in the desired type (-10)
     GENERIC, PUBLIC :: get_value     => cp_get_rv_sc,cp_get_dv_sc,cp_get_iv_sc, &
@@ -144,6 +148,6 @@
                                         cp_get_rv_ve,cp_get_dv_ve,cp_get_iv_ve, &
                                         cp_get_lv_ve,cp_get_cv_ve,cp_get_sv_ve
-    !> Set value(s) of an option in the parser by name 
-    !! 
+    !> Set value(s) of an option in the parser by name
+    !!
     !! ```
     !! FUNCTION cfg_set_value(this,name,input,create) RESULT(error)
@@ -167,6 +171,6 @@
   END TYPE cfgparser
 
-  !> Get value(s) of an option in the parser by name. 
-  !! 
+  !> Get value(s) of an option in the parser by name.
+  !!
   !! ```
   !! FUNCTION cfg_get_value(parser,name,output) RESULT(error)
@@ -177,8 +181,8 @@
   !! On error, __output__ argument is undefined (that is, left unchanged
   !! for scalar versions, **unallocated** for vector version).
-  !! 
+  !!
   !! Errors occur in the following situations:
   !! - The option has no value (-6)
-  !! - The option does not exist (-7) 
+  !! - The option does not exist (-7)
   !! - The option's value cannot be cast in the desired type (-10)
   INTERFACE cfg_get_value
@@ -189,6 +193,6 @@
   END INTERFACE
 
-    !> Set value(s) of an option in the parser by name 
-    !! 
+    !> Set value(s) of an option in the parser by name
+    !!
     !! ```
     !! FUNCTION set_value(this,name,input,create) RESULT(error)
@@ -201,13 +205,13 @@
     !! exist in _this_ parser.
     !! @warning
-    !! In such case, if the given is not valid, an assertion is raised !
+    !! In such case, if the given __name__ is not valid, an error is raised !
     !!
     !! On error (i.e. no option matches the given _name_), no values are set.
-    INTERFACE cfg_set_value 
+    INTERFACE cfg_set_value
       MODULE PROCEDURE :: cp_set_rv_sc,cp_set_dv_sc,cp_set_iv_sc, &
                           cp_set_lv_sc,cp_set_cv_sc,cp_set_sv_sc, &
                           cp_set_rv_ve,cp_set_dv_ve,cp_set_iv_ve, &
                           cp_set_lv_ve,cp_set_cv_ve,cp_set_sv_ve
-    END INTERFACE 
+    END INTERFACE
 
     !> Derived type assignment operator
@@ -230,16 +234,16 @@
     this%section = other%section
     this%values = other%values
-  END SUBROUTINE op_affect_sc 
-  
+  END SUBROUTINE op_affect_sc
+
   FUNCTION op_valid(opt) RESULT(ok)
     !! Check whether or not the option is valid (i.e. has name)
-    TYPE(option), INTENT(in)      :: opt  !! An option object 
+    TYPE(option), INTENT(in)      :: opt  !! An option object
     LOGICAL :: ok !! True if the option is valid, false otherwise.
     ok = LEN_TRIM(opt%name) > 0
   END FUNCTION op_valid
 
-  SUBROUTINE op_clear(opt) 
+  SUBROUTINE op_clear(opt)
     !! Clear and invalid the given option.
-    TYPE(option), INTENT(inout)      :: opt  !! An option object 
+    TYPE(option), INTENT(inout)      :: opt  !! An option object
     opt%name = ''
     opt%section = ''
@@ -261,45 +265,71 @@
     ENDIF
   END FUNCTION op_full_name
- 
+
   FUNCTION op_split_name(fname,sname,pname) RESULT(err)
     !> Split a full name in section and option names
-    !! 
-    !! The method splits a full name into (section,option) names. Output names (if any) are always
-    !! set to lower case. 
+    !!
+    !! The method splits a full name into (section,option) names:
+    !!
+    !! - Option basename is always set in lower-case.
+    !! - If any, section name case is left unmodified.
     !!
     !! A full name simply consists in a section name and an option name separated by a single "/".
     !!
-    !! The method never checks the validity of the output names. Consider using [[cfg_check_name(function)]] 
-    !! to do so. 
-    !! @note 
-    !! If _fname_ does not contains any "/", the method set the special name "\_\_default\_\_" for the output
-    !! section name. 
+    !! The method never checks the validity of the output names. Consider using [[cfg_check_name(function)]]
+    !! to do so.
     !! @note
-    !! On success, option and section names are set to lower case. Otherwise they are set to empty strings.
+    !! If _fname_ does not contains any "/", the method sets the special name "\_\_default\_\_" for the output
+    !! section name.
+    !! @note
+    !! On failure, output arguments are set to empty strings.
     !! @warning
-    !! If _fname_ ends with a "/", an error (-6, invalid name) is raised: the method always assumes it can
+    !! If _fname_ ends with a "/", an error (-9, invalid name) is raised: the method always assumes it can
     !! find an option part in the name.
     CHARACTER(len=*), INTENT(in)               :: fname    !! A name to split
     CHARACTER(len=:), INTENT(out), ALLOCATABLE :: sname, & !! Section part of the name
                                                   pname    !! Option part of the name
-    TYPE(error) :: err !! Error status of the method 
-    INTEGER     :: idx
+    TYPE(error)                                :: err      !! Error status of the method
+    INTEGER                       :: idx
+    CHARACTER(len=:), ALLOCATABLE :: tfname
     err = noerror ; pname = "" ; sname = ""
+    tfname = op_format(fname,sname,pname)
+    IF (LEN_TRIM(tfname) == 0) err = error("Invalid option name ("//TRIM(fname)//")",-9)
+  END FUNCTION op_split_name
+
+  FUNCTION op_format(name,sname,pname) RESULT(oname)
+    !! Format the input name to be consistent with character case requirements.
+    !!
+    !! Given a **name**, the method tries to split in section/option names.
+    !! Then it converts the option part in lower-case.
+    !!
+    !! If no section part is found (not '/' or set as first character of **name**), the
+    !! special section name `__default__` is set.
+    !!
+    !! If **name** ends with a '/', it is an error and the method returns an empty string.
+    CHARACTER(len=*), INTENT(in)  :: name  !! Name to format.
+    CHARACTER(len=:), ALLOCATABLE, INTENT(out), OPTIONAL :: sname !! Section part of the name (optional output)
+    CHARACTER(len=:), ALLOCATABLE, INTENT(out), OPTIONAL :: pname !! Option part of the name (optional output)
+    CHARACTER(len=:), ALLOCATABLE :: oname                        !! Formatted full option name.
+    INTEGER                       :: idx
+    CHARACTER(len=:), ALLOCATABLE :: zsname,zpname
+    zpname = "" ; zsname = ""
     ! splits input name in sname, pname
-    idx = INDEX(fname,'/')
-    IF (idx == LEN_TRIM(fname)) THEN
-      err = error("Invalid option name ("//TRIM(fname)//")",-9)
+    idx = INDEX(name,'/')
+    IF (idx == LEN_TRIM(name)) THEN
+      oname = ''
+      IF (PRESENT(sname)) sname = ''
+      IF (PRESENT(pname)) pname = ''
       RETURN
     ELSE IF (idx <= 1) THEN
-      sname = "__default__" ; pname = TRIM(fname)
-      IF (idx == 1) pname=pname(2:)
-    ELSE
-      sname = fname(:idx-1)
-      pname = fname(idx+1:LEN_TRIM(fname))
-    ENDIF
-    ! 17/12/2014: set option name to lower 
-    pname = str_to_lower(pname)
-    sname = str_to_lower(sname)
-  END FUNCTION op_split_name
+      zsname = "__default__" ; zpname = to_lower(TRIM(name))
+      IF (idx == 1) zpname=zpname(2:)
+    ELSE
+      zsname = name(:idx-1)
+      zpname = to_lower(name(idx+1:LEN_TRIM(name)))
+    ENDIF
+    oname = zsname//"/"//zpname
+    IF (PRESENT(sname)) sname = zsname
+    IF (PRESENT(pname)) pname = zpname 
+  END FUNCTION op_format
 
   FUNCTION op_greater_than(left,right) RESULT(ret)
@@ -309,5 +339,5 @@
     TYPE(option), INTENT(in) :: left  !! LHS option.
     TYPE(option), INTENT(in) :: right !! RHS option.
-    LOGICAL :: ret 
+    LOGICAL :: ret
       !! .true. if LHS is _greater_ than RHS (based on section and option name)
     ret = LGT(op_full_name(left),op_full_name(right))
@@ -320,5 +350,5 @@
     TYPE(option), INTENT(in) :: left  !! LHS option.
     TYPE(option), INTENT(in) :: right !! RHS option.
-    LOGICAL :: ret 
+    LOGICAL :: ret
       !! .true. if LHS is _less_ than RHS (based on section and option name)
     ret = LLT(op_full_name(left),op_full_name(right))
@@ -327,7 +357,7 @@
   FUNCTION op_to_str(opt,num_values) RESULT(str)
     !! Get the string representation of a option object
-    !! @note 
+    !! @note
     !! If the object is not valid an empty string is returned.
-    TYPE(option), INTENT(in) :: opt 
+    TYPE(option), INTENT(in) :: opt
       !! A option object
     INTEGER, INTENT(in), OPTIONAL :: num_values
@@ -343,5 +373,5 @@
     str = TRIM(opt%name)//" = " ; np = LEN(str)
     ALLOCATE(CHARACTER(len=np) :: nspcs) ; nspcs(1:) = " "
-    ! stores the error but do not check... 
+    ! stores the error but do not check...
     ret = words_to_vector(opt%values,vec)
     IF (.NOT.ALLOCATED(vec)) RETURN
@@ -382,13 +412,22 @@
 
   FUNCTION cfg_check_name(name) RESULT(valid)
-    !! Check if a name is valid
-    !!
-    !! A valid option/section name begins with a letter and is followed by any 
-    !! number of alphanumeric characters and underscore (`[A-Za-z][A-Za-z0-9\_]\*`).
+    !! Check if a name is valid.
+    !!
+    !! If **name** contains a '/' it is assumed to be a full option name. In such case
+    !! both parts of the name are checked against section/option names requirements (see below).
+    !!
+    !! Otherwise it is assumed to be the basename of the option.
+    !! 
+    !! A valid option (base) name is an alphanumeric sequence in lower-case that always begin by
+    !! a letter.
+    !!
+    !! A valid section name is and alphanumeric sequence (in any case) that always begins by
+    !! by a letter.
     CHARACTER(len=*), INTENT(in) :: name !! A string with the name to check.
     LOGICAL :: valid                     !! .true. if the name is valid, .false. otherwise
     INTEGER                       :: i
-    CHARACTER(len=26), PARAMETER  :: alpha = "abcdefghijklmnopqrstuvwxyz"
-    CHARACTER(len=12), PARAMETER  :: num   = "0123456789_"
+    CHARACTER(len=26), PARAMETER  :: alpha  = "abcdefghijklmnopqrstuvwxyz"
+    CHARACTER(len=26), PARAMETER  :: ualpha = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
+    CHARACTER(len=12), PARAMETER  :: num    = "0123456789_"
     CHARACTER(len=:), ALLOCATABLE :: pname,sname
     TYPE(error)                   :: err
@@ -401,5 +440,5 @@
       ENDIF
     ELSE
-      pname = str_to_lower(TRIM(name))
+      pname = to_lower(TRIM(name))
       sname = "__default__"
     ENDIF
@@ -416,19 +455,34 @@
       i = INDEX(sname,CHAR(32))
       IF (i /= 0.OR.LEN_TRIM(sname) <= 0) RETURN
-      valid = (VERIFY(sname(1:1),alpha) == 0 .AND.VERIFY(TRIM(sname),alpha//"/"//num) == 0)
+      valid = (VERIFY(sname(1:1),ualpha//alpha) == 0 .AND.VERIFY(TRIM(sname),ualpha//alpha//num) == 0)
     ENDIF
   END FUNCTION cfg_check_name
 
-  FUNCTION cfg_count(this) RESULT(num)
+  FUNCTION cfg_count(this,section) RESULT(num)
     !! Get the total number of option in the parser.
     !!
+    !! If a section name is given in argument, the method returns the count for the given section only.
+    !!
+    !! To get the number of top-level options (i.e. that belongs to the default section) the keyword \_\_default\_\_
+    !! should be set for the section argument.
+    !!
+    !! If __section__ is not defined in the parser, the method returns 0.
+    !!
     !! @internal
-    !! If no options are defined, then it implies that the internal vector of options is 
+    !! If no options are defined, then it implies that the internal vector of options is
     !! not allocated.
-    OBJECT(cfgparser), INTENT(in) :: this !! A cfgparser object to search in 
-    INTEGER :: num                        !! Number of current options registered in the parser.
+    OBJECT(cfgparser), INTENT(in)          :: this    !! A cfgparser object to search in
+    CHARACTER(len=*), INTENT(in), OPTIONAL :: section !! Optional section name to search in.
+    INTEGER :: num                                    !! Number of current options registered in the parser.
+    INTEGER :: i
     num = 0
     IF(.NOT.ALLOCATED(this%options)) RETURN
-    num = SIZE(this%options)
+    IF (.NOT.PRESENT(section)) THEN
+      num = SIZE(this%options)  
+    ELSE
+      DO i=1, SIZE(this%options)
+        IF (this%options(i)%section == section) num = num+1
+      ENDDO
+    ENDIF
   END FUNCTION cfg_count
 
@@ -469,5 +523,5 @@
         ! Found a match so start looking again
         found = (tmp(j) == this%options(i)%section .OR. &
-                 this%options(i)%section == "__default__") 
+                 this%options(i)%section == "__default__")
         IF (found) EXIT
       ENDDO
@@ -482,37 +536,58 @@
   END FUNCTION cfg_section_names
 
-  FUNCTION cfg_option_names(this) RESULT(list)
+  FUNCTION cfg_option_names(this,secname) RESULT(list)
     !! Get the list of option names.
     !!
     !! @note
     !! If the parser does not have options, the vector is still allocated but with 0 elements.
-    OBJECT(cfgparser), INTENT(in) :: this                     !! A cfgparser object to process. 
-    CHARACTER(len=st_slen), DIMENSION(:), ALLOCATABLE :: list !! List of option names. 
-    INTEGER               :: i,no
+    OBJECT(cfgparser), INTENT(in)                     :: this    !! A cfgparser object to process.
+    CHARACTER(len=*), INTENT(in), OPTIONAL            :: secname !! Optional section name to search in.
+    CHARACTER(len=st_slen), DIMENSION(:), ALLOCATABLE :: list    !! List of option names.
+    INTEGER               :: j,i,no,nso
     no = cfg_count(this)
-    ALLOCATE(list(no))
-    IF (no == 0) RETURN
-    DO i=1,no
-      IF (this%options(i)%section == "__default__") THEN
-        list(i) = TRIM(this%options(i)%name)
-      ELSE
-        list(i) = TRIM(this%options(i)%section)//"/"//TRIM(this%options(i)%name)
-      ENDIF
-    ENDDO
+    IF (no == 0) THEN
+       ALLOCATE(list(no)) ; RETURN
+    ENDIF
+    IF (PRESENT(secname)) THEN
+      IF (.NOT.cfg_has_section(this,TRIM(secname))) THEN
+        ALLOCATE(list(no)) ; RETURN
+      ELSE
+        nso = 0
+        DO i=1,no ; IF (this%options(i)%section == TRIM(secname)) nso = nso + 1 ; ENDDO
+        ALLOCATE(list(nso))
+        IF (nso == 0) RETURN
+        j = 1
+        DO i=1,no
+          IF (this%options(i)%section == TRIM(secname)) THEN
+            list(j) = TRIM(this%options(i)%section)//"/"//TRIM(this%options(i)%name) ; j=j+1
+          ENDIF
+        ENDDO
+      ENDIF
+    ELSE
+      ALLOCATE(list(no))
+      DO i=1,no
+        IF (this%options(i)%section == "__default__") THEN
+          list(i) = TRIM(this%options(i)%name)
+        ELSE
+          list(i) = TRIM(this%options(i)%section)//"/"//TRIM(this%options(i)%name)
+        ENDIF
+      ENDDO
+    ENDIF
   END FUNCTION cfg_option_names
 
   FUNCTION cfg_has_section(this,name) RESULT(yes)
     !! Check if parser has section by name
+    !!
+    !! @note
+    !! Keep in mind that section name in the configuration are case-sensitive.
     OBJECT(cfgparser), INTENT(in) :: this !! cfgparser object
     CHARACTER(len=*), INTENT(in)  :: name !! Name of the section to search
     LOGICAL :: yes                        !! .true. if the section exists, .false. otherwise
-    CHARACTER(len=:), ALLOCATABLE :: zname
     INTEGER                       :: i,no
     yes = .false.
     no = cfg_count(this)
     IF (no == 0) RETURN
-    zname = str_to_lower(name)
     DO i = 1,no
-      IF (this%options(i)%section == zname) THEN
+      IF (this%options(i)%section == name) THEN
         yes = .true.
         RETURN
@@ -527,15 +602,12 @@
     LOGICAL :: yes                        !! .true. if the option is found, .false. otherwise
     CHARACTER(len=:), ALLOCATABLE :: pname,zname
-    INTEGER                       :: i,no
+    INTEGER                       :: i,no,iscan
     yes = .false.
     no = cfg_count(this)
     IF (no == 0) RETURN
-    IF (SCAN(name,"/") <= 0) THEN
-      zname = "__default__"//"/"//str_to_lower(TRIM(name))
-    ELSE
-      zname = str_to_lower(TRIM(name))
-    ENDIF
+    zname = op_format(name)
+    IF (LEN_TRIM(zname) == 0) RETURN
     DO i = 1,no
-      pname = op_full_name(this%options(i)) 
+      pname = op_full_name(this%options(i))
       IF (pname == zname) THEN
         yes = .true.
@@ -545,5 +617,5 @@
   END FUNCTION cfg_has_option
 
-  SUBROUTINE cfg_sort_options(this) 
+  SUBROUTINE cfg_sort_options(this)
     !! Sort the options in the parser (alphabetiCALLy).
     OBJECT(cfgparser), INTENT(inout) :: this !! A cfgparser object
@@ -552,21 +624,15 @@
     IF (no == 0) RETURN
     CALL insertionSort(this%options)
-  END SUBROUTINE cfg_sort_options 
+  END SUBROUTINE cfg_sort_options
 
   SUBROUTINE cfg_remove_option(this,name)
     !! Remove an option from parser by name.
-    OBJECT(cfgparser), INTENT(inout) :: this !! A cfgparser object to search in 
+    OBJECT(cfgparser), INTENT(inout) :: this !! A cfgparser object to search in
     CHARACTER(len=*), INTENT(in)     :: name !! The name of the option to remove
-    CHARACTER(len=:), ALLOCATABLE    :: zname,pname
     INTEGER                                 :: no,idx,i,j
     TYPE(option), DIMENSION(:), ALLOCATABLE :: tmp
-    IF (SCAN(name,"/") <= 0) THEN
-      zname = "__default__"//"/"//str_to_lower(TRIM(name))
-    ELSE
-      zname = str_to_lower(TRIM(name))
-    ENDIF
-    idx = cp_get_opt_idx(this,zname)
+    idx = cp_get_opt_idx(this,name)
+    IF (idx == -1) RETURN
     no = cfg_count(this)
-    IF (idx == -1) RETURN
     ! only one opt
     IF (no == 1) THEN
@@ -589,5 +655,5 @@
       this%options(i) = tmp(i)
       CALL op_clear(tmp(i))
-    ENDDO 
+    ENDDO
     DEALLOCATE(tmp)
   END SUBROUTINE cfg_remove_option
@@ -597,21 +663,18 @@
     !!
     !! The method removes all the options that belong to the given section name.
-    OBJECT(cfgparser), INTENT(inout) :: this 
-      !! A cfgparser object to search in 
+    OBJECT(cfgparser), INTENT(inout) :: this
+      !! A cfgparser object to search in
     CHARACTER(len=*), INTENT(in)     :: name
       !! The name of the section to remove
-    CHARACTER(len=:), ALLOCATABLE           :: zname
     INTEGER                                 :: no,i,j,icount
     INTEGER, DIMENSION(:), ALLOCATABLE      :: idxs,itmp
     TYPE(option), DIMENSION(:), ALLOCATABLE :: tmp
-     
     no = cfg_count(this)
     IF (no == 0) RETURN
-    zname = str_to_lower(TRIM(name))
     ALLOCATE(itmp(no))
     itmp(:) = -1
     icount = 0
     DO i=1,no
-      IF (TRIM(this%options(i)%section) == zname) THEN
+      IF (TRIM(this%options(i)%section) == TRIM(name)) THEN
         itmp(icount+1) = i
         icount = icount + 1
@@ -627,5 +690,5 @@
        DEALLOCATE(this%options)
        RETURN
-    ENDIF 
+    ENDIF
     ALLOCATE(tmp(icount))
     j = 1
@@ -650,5 +713,5 @@
     !! Read configuration file
     !!
-    !! @note 
+    !! @note
     !! If the library support C bindings, the method can read included files which are defined
     !! by the __#include <...>__ directive (see [p_cfgparse](here) from more details).
@@ -662,13 +725,13 @@
       !! An error with the first error encountered
     INTEGER                       :: i
-    LOGICAL                       :: zoverride,ok 
-    TYPE(words)                   :: incfiles 
+    LOGICAL                       :: zoverride,ok
+    TYPE(words)                   :: incfiles
     CHARACTER(len=:), ALLOCATABLE :: name
     CHARACTER(len=st_slen)        :: isec
-    err = noerror 
+    err = noerror
     zoverride = .false. ; IF (PRESENT(override)) zoverride = override
     isec = "__default__"
     name = TRIM(path)
-    i = INDEX(name,'/',.true.) ; IF (i /= 0) name = name(i+1:) 
+    i = INDEX(name,'/',.true.) ; IF (i /= 0) name = name(i+1:)
     IF (i == 0) THEN
       name = fs_realpath("./"//path)
@@ -710,5 +773,5 @@
     no = cfg_count(this)
     IF (no == 0) THEN
-      err = error("No options to write",-7) 
+      err = error("No options to write",-7)
       RETURN
     ENDIF
@@ -728,5 +791,5 @@
       WRITE(lu,'(a)') op_to_str(this%options(i),nv)
     ENDDO
-  END FUNCTION cfg_write_config 
+  END FUNCTION cfg_write_config
 
   ! internal (private methods)
@@ -751,5 +814,5 @@
   FUNCTION cp_get_opt_idx(this,name) RESULT(idx)
     !! Get the index of an option by name in the parser.
-    !! 
+    !!
     !! The method searches in the parser for the option with the given (full) __name__.
     !! If found, it returns the index of the option in the internal vector of options. Otherwise
@@ -763,9 +826,6 @@
     no = cfg_count(this)
     IF (no == 0) RETURN
-    IF (SCAN(name,"/") <= 0) THEN
-      zname = "__default__"//"/"//str_to_lower(TRIM(name))
-    ELSE
-      zname = str_to_lower(TRIM(name))
-    ENDIF
+    zname = op_format(name) ! prepare the name to search.
+    IF (LEN_TRIM(zname) == 0) RETURN
     DO i=1,no
       pname = op_full_name(this%options(i))
@@ -780,27 +840,28 @@
     !! Update an option in the parser.
     !!
-    !! The attempts to update the option in the parser that matches __opt__ name.
-    !! 
-    !! If __name__ is given it is used instead of __opt__ name.
-    !!
-    !! If no option is found, __opt__ is appended in the parser. Otherwise the matched
-    !! option is updated (i.e. its values are set to __opt__ values).
-    !!
-    !! If the option is not valid, the method does nothing and -X error status is returned.
+    !! The method attempts to update the option in the parser.
+    !!
+    !! If __sname__ is set to empty string, the method searches for the option
+    !! in the default section.
+    !!
+    !! If no option is found, The the option is appended in the parser. Otherwise it is updated
+    !! with the content of __values__.
+    !!
+    !! If the option name is not valid, the method does nothing and -9 error status is returned.
     !!
     !! @internal
     !! The method performs the same kind of operations than the setters except that it
-    !! expects raw data ([[strings(module):words(type)]]).
+    !! expects raw data ([[string_op(module):words(type)]]).
     OBJECT(cfgparser), INTENT(inout) :: this   !! cfgparser object to process.
     CHARACTER(len=*), INTENT(in)     :: sname  !! Name of the section.
-    CHARACTER(len=*), INTENT(in)     :: pname  !! Name of the option.
+    CHARACTER(len=*), INTENT(in)     :: pname  !! Basename of the option.
     TYPE(words), INTENT(in)          :: values !! Raw values.
-    TYPE(error) :: err !! Error status.
+    TYPE(error)                      :: err    !! Error status.
     CHARACTER(len=:), ALLOCATABLE :: zsname,fname
     INTEGER                       :: i
     err = noerror
-    zsname = str_to_lower(TRIM(sname))
-    IF (LEN_TRIM(zsname) == 0 ) zsname = "__default__"
-    fname = zsname//"/"//str_to_lower(TRIM(pname))
+    zsname = TRIM(sname)
+    IF (LEN_TRIM(sname) == 0) zsname = "__default__"
+    fname = zsname//"/"//to_lower(TRIM(pname))
     IF (.NOT.cfg_check_name(fname)) THEN
        err = error("Invalid option (no name)",-9)
@@ -816,11 +877,8 @@
   END FUNCTION cp_update_opt
 
-
-  FUNCTION cp_add_opt(this,sname,pname,values) RESULT(err) 
+  FUNCTION cp_add_opt(this,sname,pname,values) RESULT(err)
     !! Add an option to the parser.
     !!
     !! In order to add an option to the default section, _sname_ should be left empty or set to "\_\_default\_\_".
-    !! 
-    !! If given, _opt_ points to the new option on output. If an error occured the pointer is null.
     !!
     !! The following error code can be returned:
@@ -828,10 +886,10 @@
     !!  - -8, the option already exists.
     !!  - -9, option name is not valid.
-    OBJECT(cfgparser), INTENT(inout) :: this   
+    OBJECT(cfgparser), INTENT(inout) :: this
       !! A cfgparser object to process.
     CHARACTER(len=*), INTENT(in)     :: sname
       !! Section name.
     CHARACTER(len=*), INTENT(in)     :: pname
-      !! Option name.
+      !! Option basename.
     TYPE(words), INTENT(in)          :: values
       !! Values to set.
@@ -839,8 +897,7 @@
       !! Return error status.
     CHARACTER(len=:), ALLOCATABLE           :: zsname,fname
-    TYPE(option), DIMENSION(:), ALLOCATABLE :: tmp 
+    TYPE(option), DIMENSION(:), ALLOCATABLE :: tmp
     INTEGER                                 :: no,i
-
-    TYPE(option) :: sca 
+    TYPE(option)                            :: sca
 
     err = noerror
@@ -848,5 +905,5 @@
     no = cfg_count(this)
     IF (LEN_TRIM(zsname) == 0) zsname = "__default__"
-    fname = TRIM(zsname)//"/"//TRIM(pname)
+    fname = TRIM(zsname)//"/"//to_lower(TRIM(pname))
     ! check name
     IF (.NOT.cfg_check_name(fname)) THEN
@@ -864,5 +921,5 @@
     ! build option
     CALL op_clear(sca)
-    sca%name = pname
+    sca%name = to_lower(TRIM(pname))
     sca%section = zsname
     sca%values = values
@@ -874,12 +931,12 @@
       ! parser has options: increase this%options size (ugly copy).
       ALLOCATE(tmp(no))
-      DO i =1,no 
-        tmp(i) = this%options(i) 
+      DO i =1,no
+        tmp(i) = this%options(i)
         CALL op_clear(this%options(i))
       ENDDO
       DEALLOCATE(this%options)
       ALLOCATE(this%options(no+1))
-      DO i =1,no 
-        this%options(i) = tmp(i) 
+      DO i =1,no
+        this%options(i) = tmp(i)
         CALL op_clear(tmp(i))
       ENDDO
@@ -898,10 +955,10 @@
     !!  - -6, the option does not have value(s).
     !!  - -10, the value cannot be converted in the output type.
-    OBJECT(cfgparser), INTENT(in) :: this   !! Cfgparser object 
+    OBJECT(cfgparser), INTENT(in) :: this   !! Cfgparser object
     CHARACTER(len=*), INTENT(in)  :: name   !! (Full) Name of the option to get
     REAL(kind=4), INTENT(out)     :: output !! Output value
-    TYPE(error) :: err 
+    TYPE(error) :: err
       !! Error status
-    INTEGER :: idx 
+    INTEGER :: idx
     CHARACTER(len=:), ALLOCATABLE :: tmp
     err = noerror
@@ -918,5 +975,5 @@
         err = error("Option "//TRIM(name)//" has no value",-6)
       ELSE
-        IF(.NOT.from_string(tmp,output)) & 
+        IF(.NOT.from_string(tmp,output)) &
         err = error(TRIM(name)//": Cannot convert "//tmp//" to real.",-10)
       ENDIF
@@ -931,10 +988,10 @@
     !!  - -6, the option does not have value(s).
     !!  - -10, the value cannot be converted in the output type.
-    OBJECT(cfgparser), INTENT(in) :: this   !! Cfgparser object 
+    OBJECT(cfgparser), INTENT(in) :: this   !! Cfgparser object
     CHARACTER(len=*), INTENT(in)  :: name   !! (Full) Name of the option to get
     REAL(kind=8), INTENT(out)     :: output !! Output value
-    TYPE(error) :: err 
+    TYPE(error) :: err
       !! Error status
-    INTEGER :: idx 
+    INTEGER :: idx
     CHARACTER(len=:), ALLOCATABLE :: tmp
     err = noerror
@@ -951,5 +1008,5 @@
         err = error("Option "//TRIM(name)//" has no value",-6)
       ELSE
-        IF(.NOT.from_string(tmp,output)) & 
+        IF(.NOT.from_string(tmp,output)) &
         err = error(TRIM(name)//": Cannot convert "//tmp//" to double.",-10)
       ENDIF
